# RevKit: A Toolkit for Reversible Circuit Design (www.revkit.org)
# Copyright (C) 2009-2011  The RevKit Developers <revkit@informatik.uni-bremen.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from PyQt4.QtCore import Qt
from PyQt4.QtGui import QTableWidget, QTableWidgetItem

class SpecificationTable( QTableWidget ):
    def __init__( self, parent = None ):
        QTableWidget.__init__( self, parent )
        self.verticalHeader().hide()

    def load( self, spec ):
        self.clear()
        self.setColumnCount( spec.num_inputs + spec.num_outputs )
        self.setRowCount( sum( 1 for _ in spec.entries ) )
        self.setHorizontalHeaderLabels( spec.inputs + spec.outputs )

        for row, entry in enumerate( spec.entries ):
            for column, entry in enumerate( entry[0] + entry[1] ):
                item = QTableWidgetItem( "-" if entry is None else str( int( entry ) ) )
                item.setFlags( Qt.ItemIsSelectable | Qt.ItemIsEnabled )
                if column >= spec.num_inputs:
                    item.setBackground( Qt.gray )
                self.setItem( row, column, item )

        self.resizeColumnsToContents()

